Index: protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/session/learn/LearnState.java	(revision 31)
@@ -0,0 +1,126 @@
+package geniusweb.protocol.session.learn;
+
+import java.util.Collections;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.stream.Collectors;
+
+import geniusweb.actions.Action;
+import geniusweb.actions.LearningDone;
+import geniusweb.actions.PartyId;
+import geniusweb.inform.Agreements;
+import geniusweb.progress.Progress;
+import geniusweb.protocol.ProtocolException;
+import geniusweb.protocol.session.DefaultSessionState;
+import geniusweb.protocol.session.SessionResult;
+import geniusweb.references.PartyWithProfile;
+
+/**
+ * Stores the state for Learn protocol. Immutable.
+ */
+public class LearnState extends DefaultSessionState<LearnState, LearnSettings> {
+
+	/**
+	 * 
+	 * @param actions       the actions done by the parties
+	 * @param conns         the existing party connections. we assume ownership
+	 *                      of this so it should not be modified although
+	 *                      connections may of course break. If null, default
+	 *                      empty list is used. Can be less than 2 parties in
+	 *                      the first phases of the setup.
+	 * @param progress      the {@link Progress} line. can be null
+	 * @param settings      the {@link LearnSettings}
+	 * @param partyprofiles map with the {@link PartyWithProfile} for connected
+	 *                      parties. null is equivalent to an empty map.
+	 * @param e             the {@link ProtocolException}, or null if none
+	 *                      occurred.
+	 */
+	public LearnState(List<Action> actions, List<PartyId> conns,
+			Progress progress, LearnSettings settings,
+			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
+		super(actions, conns, progress, settings, partyprofiles, e);
+	}
+
+	/**
+	 * Creates the initial state from the given settings and progress=null
+	 * 
+	 * @param settings the {@link LearnSettings}
+	 */
+	public LearnState(LearnSettings settings) {
+		this(Collections.emptyList(), Collections.emptyList(), null, settings,
+				null, null);
+
+	}
+
+	@Override
+	public LearnState with(List<Action> actions, List<PartyId> conns,
+			Progress progr, LearnSettings settings,
+			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
+		return new LearnState(actions, conns, progr, settings, partyprofiles,
+				e);
+	}
+
+	@Override
+	public Agreements getAgreements() {
+		return new Agreements();
+	}
+
+	@Override
+	public SessionResult getResult() {
+		return new SessionResult(getPartyProfiles(), getAgreements(),
+				Collections.emptyMap(), null);
+	}
+
+	@Override
+	public boolean isFinal(long currentTimeMs) {
+		Set<PartyId> done = getDoneLearning();
+		// if done is empty we're probably still starting up.
+		return super.isFinal(currentTimeMs)
+				|| (!done.isEmpty() && done.containsAll(getConnections()));
+	}
+
+	/**
+	 * 
+	 * @param e the error that occured
+	 * @return a new state with the error set.
+	 */
+	@Override
+	public LearnState with(ProtocolException e) {
+		return new LearnState(getActions(), getConnections(), getProgress(),
+				getSettings(), getPartyProfiles(), e);
+	}
+
+	@Override
+	public LearnSettings getSettings() {
+		return super.getSettings();
+	}
+
+	/**
+	 * 
+	 * @param actor  the known real actor that did this action
+	 * @param action an {@link Action}
+	 * @return null if action seems ok, or message explaining why not.
+	 */
+	@Override
+	public String checkAction(PartyId actor, Action action) {
+		String msg = super.checkAction(actor, action);
+		if (msg != null)
+			return msg;
+		if (getDoneLearning().contains(actor))
+			return "actor already was done learning";
+		if (!(action instanceof LearningDone))
+			return "Action " + action + " is not allowed";
+		return null;
+	}
+
+	/**
+	 * 
+	 * @return set of parties that reported they are done with learning.
+	 */
+	private Set<PartyId> getDoneLearning() {
+		return getActions().stream().map(party -> party.getActor())
+				.collect(Collectors.toSet());
+	}
+
+}
Index: protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac/MOPAC.java	(revision 31)
@@ -46,9 +46,9 @@
  * specified initially in the settings do participate (no late joining in)
  * 
- * <h1>parameter</h1> MOPAC parties can receive a parameter <code>power</code>
+ * <h2>parameter</h2> MOPAC parties can receive a parameter <code>power</code>
  * containing a Integer. This parameter is picked up by this protocol, for
  * handling the agreement extraction from the offers. Power=1 for parties that
  * do not have the power parameter.
- * <h1>Protocol steps</h1>
+ * <h2>Protocol steps</h2>
  * 
  * <ol>
Index: protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/mopac2/MOPAC2.java	(revision 31)
@@ -46,9 +46,9 @@
  * specified initially in the settings do participate (no late joining in)
  * 
- * <h1>parameter</h1> MOPAC parties can receive a parameter <code>power</code>
+ * <h2>parameter</h2> MOPAC parties can receive a parameter <code>power</code>
  * containing a Integer. This parameter is picked up by this protocol, for
  * handling the agreement extraction from the offers. Power=1 for parties that
  * do not have the power parameter.
- * <h1>Protocol steps</h1>
+ * <h2>Protocol steps</h2>
  * 
  * <ol>
Index: protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/saop/SAOP.java	(revision 31)
@@ -4,4 +4,5 @@
 import java.sql.Date;
 import java.text.SimpleDateFormat;
+import java.util.Collections;
 import java.util.List;
 import java.util.Timer;
@@ -25,4 +26,5 @@
 import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
 import geniusweb.protocol.partyconnection.ProtocolToPartyConnFactory;
+import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.SessionProtocol;
 import geniusweb.protocol.session.SessionSettings;
@@ -72,15 +74,13 @@
 	private final Reporter log;
 
+	// these 4 variables are why protocols are so complex.
 	private SAOPState state = null; // mutable!
 	private volatile AtomicBoolean isFinishedInfoSent = new AtomicBoolean(
 			false);
 	private volatile Timer deadlinetimer = null;
-
-	/**
-	 * 
-	 * @param state  normally the initial state coming from SAOPSettings
-	 * @param logger the Reporter to log to
-	 */
-	public SAOP(SAOPState state, Reporter logger) {
+	private volatile ProtocolToPartyConnections conns;
+
+	public SAOP(SAOPState state, Reporter logger,
+			ProtocolToPartyConnections connects) {
 		if (state == null) {
 			throw new NullPointerException("state must be not null");
@@ -92,4 +92,15 @@
 		this.log = logger;
 		this.state = state;
+		this.conns = connects;
+	}
+
+	/**
+	 * 
+	 * @param state  normally the initial state coming from SAOPSettings
+	 * @param logger the Reporter to log to
+	 */
+	public SAOP(SAOPState state, Reporter logger) {
+		this(state, logger,
+				new ProtocolToPartyConnections(Collections.emptyList()));
 	}
 
@@ -175,5 +186,9 @@
 		}
 		for (int i = 0; i < participants.size(); i++) {
-			setState(this.state.with(connections.get(i), participants.get(i)));
+			// now we bookkeep the connections ourselves,
+			// and update the state to keep in sync.
+			conns = conns.with(connections.get(i));
+			setState(this.state.with(connections.get(i).getParty(),
+					participants.get(i)));
 		}
 	}
@@ -219,9 +234,9 @@
 	 */
 	protected synchronized void setupParties() throws ProtocolException {
-		for (ProtocolToPartyConn conn : state.getConnections()) {
+		for (ProtocolToPartyConn conn : conns) {
 			conn.addListener(action -> actionRequest(conn, action));
 		}
 
-		for (ProtocolToPartyConn connection : state.getConnections()) {
+		for (ProtocolToPartyConn connection : conns) {
 			try {
 				sendSettings(connection);
@@ -282,5 +297,5 @@
 			}
 			// FIXME? this ignores possible broadcast errors
-			state.getConnections().broadcast(new ActionDone(action));
+			conns.broadcast(new ActionDone(action));
 			setState(state.with(partyconn.getParty(), action));
 			if (!state.isFinal(System.currentTimeMillis()))
@@ -298,8 +313,8 @@
 	 * @throws IOException
 	 */
-	private synchronized void nextTurn() {
+	synchronized void nextTurn() {
 		PartyId party = state.getNextActor();
 		try {
-			state.getConnections().get(party).send(new YourTurn());
+			conns.get(party).send(new YourTurn());
 		} catch (IOException e) {
 			handleError("failed to send YourTurn", party, e);
@@ -318,7 +333,9 @@
 		if (e instanceof ProtocolException) {
 			setState(state.with((ProtocolException) e));
+
 		} else {
 			setState(state.with(new ProtocolException(message, party, e)));
 		}
+		setState(state.withoutParty(party));
 		log.log(Level.WARNING, "SAOP protocol intercepted error due to party "
 				+ party + ":" + message, e);
@@ -356,5 +373,5 @@
 			return;
 		Inform finished = new Finished(state.getAgreements());
-		for (ProtocolToPartyConn conn : state.getConnections()) {
+		for (ProtocolToPartyConn conn : conns) {
 			sendFinish(conn, finished);
 		}
Index: protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/saop/SAOPSettings.java	(revision 31)
@@ -119,6 +119,5 @@
 			throw new IllegalArgumentException(
 					"Team must be size 1 but found " + team);
-		List<TeamInfo> newparts = new LinkedList<>(
-				participants);
+		List<TeamInfo> newparts = new LinkedList<>(participants);
 		newparts.add(team);
 		return new SAOPSettings(newparts, deadline);
Index: protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/session/saop/SAOPState.java	(revision 31)
@@ -2,10 +2,7 @@
 
 import java.util.Collections;
-import java.util.HashMap;
-import java.util.LinkedList;
+import java.util.HashSet;
 import java.util.List;
 import java.util.Map;
-import java.util.Set;
-import java.util.stream.Collectors;
 
 import geniusweb.actions.Accept;
@@ -19,9 +16,6 @@
 import geniusweb.progress.ProgressRounds;
 import geniusweb.protocol.ProtocolException;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConn;
-import geniusweb.protocol.partyconnection.ProtocolToPartyConnections;
 import geniusweb.protocol.session.DefaultSessionState;
 import geniusweb.protocol.session.SessionResult;
-import geniusweb.protocol.session.SessionSettings;
 import geniusweb.references.PartyWithProfile;
 
@@ -29,14 +23,13 @@
  * Immutable.
  */
-public class SAOPState extends DefaultSessionState {
+public class SAOPState extends DefaultSessionState<SAOPState, SAOPSettings> {
 
 	/**
 	 * 
 	 * @param actions       the actions done by the parties
-	 * @param conns         the existing party connections. we assume ownership
-	 *                      of this so it should not be modified although
-	 *                      connections may of course break. If null, default
+	 * @param conns         the existing party connections. If null, default
 	 *                      empty list is used. Can be less than 2 parties in
-	 *                      the first phases of the setup.
+	 *                      the first phases of the setup or after parties
+	 *                      disconnected.
 	 * @param progress      the {@link Progress} line. can be null
 	 * @param settings      the {@link SAOPSettings}
@@ -46,8 +39,15 @@
 	 *                      occurred.
 	 */
-	public SAOPState(List<Action> actions, ProtocolToPartyConnections conns,
-			Progress progress, SessionSettings settings,
+	public SAOPState(List<Action> actions, List<PartyId> conns,
+			Progress progress, SAOPSettings settings,
 			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
 		super(actions, conns, progress, settings, partyprofiles, e);
+	}
+
+	@Override
+	public SAOPState with(List<Action> actions, List<PartyId> conns,
+			Progress progr, SAOPSettings settings,
+			Map<PartyId, PartyWithProfile> partyprofiles, ProtocolException e) {
+		return new SAOPState(actions, conns, progr, settings, partyprofiles, e);
 	}
 
@@ -58,57 +58,7 @@
 	 */
 	public SAOPState(SAOPSettings settings) {
-		this(Collections.emptyList(),
-				new ProtocolToPartyConnections(Collections.emptyList()), null,
-				settings, null, null);
+		this(Collections.emptyList(), Collections.emptyList(), null, settings,
+				null, null);
 
-	}
-
-	/**
-	 * 
-	 * @param connection   the new {@link ProtocolToPartyConn}
-	 * @param partyprofile the {@link PartyWithProfile} that is associated with
-	 *                     this state
-	 * @return new SessionState with the new connection added. This call ignores
-	 *         the progress (does not check isFinal) because SAOP uses this
-	 *         during the setup where the deadline is not yet relevant. The
-	 *         connection should be informed about the partyprofile but the
-	 *         state currently indicate if that already happened or not.
-	 */
-	public SAOPState with(ProtocolToPartyConn connection,
-			PartyWithProfile partyprofile) {
-		// Only called from the SAOP initialization phase.
-		ProtocolToPartyConnections newconns = getConnections().with(connection);
-		Map<PartyId, PartyWithProfile> newprofiles = new HashMap<>(
-				getPartyProfiles());
-		newprofiles.put(connection.getParty(), partyprofile);
-		return new SAOPState(getActions(), newconns, getProgress(),
-				getSettings(), newprofiles, null);
-	}
-
-	/**
-	 * 
-	 * @param e the error that occured
-	 * @return a new state with the error set.
-	 */
-	public SAOPState with(ProtocolException e) {
-		return new SAOPState(getActions(), getConnections(), getProgress(),
-				getSettings(), getPartyProfiles(), e);
-	}
-
-	/**
-	 * Sets the progress for this session. Can be set only if progress=null.
-	 * 
-	 * @param newprogress the new progress
-	 * @return new SAOPState with the progress set
-	 */
-	public SAOPState with(Progress newprogress) {
-		if (newprogress == null) {
-			throw new IllegalArgumentException("newprogress must be not null");
-		}
-		if (getProgress() != null) {
-			return this;
-		}
-		return new SAOPState(getActions(), getConnections(), newprogress,
-				getSettings(), getPartyProfiles(), getError());
 	}
 
@@ -131,5 +81,6 @@
 						&& bid.equals(((Accept) act).getBid()));
 		if (allaccept)
-			agree = agree.with(new Agreements(bid, getParties()));
+			agree = agree
+					.with(new Agreements(bid, new HashSet<>(getParties())));
 		return agree;
 	}
@@ -139,7 +90,6 @@
 	 * @return all currently connected parties.
 	 */
-	private Set<PartyId> getParties() {
-		return getConnections().stream().map(conn -> conn.getParty())
-				.collect(Collectors.toSet());
+	public List<PartyId> getParties() {
+		return getConnections();
 	}
 
@@ -153,59 +103,33 @@
 
 	@Override
-	public SAOPSettings getSettings() {
-		return (SAOPSettings) super.getSettings();
+	public SAOPState with(PartyId actor, Action action) {
+		return super.with(actor, action).with(advanceProgress());
 	}
 
-	/**
-	 * @param actor  the actor that did this action. Can be used to check if
-	 *               action is valid. NOTICE caller has to make sure the current
-	 *               state is not final.
-	 * @param action the action that was proposed by actor.
-	 * @return new SAOPState with the action added as last action.
-	 */
+	@Override
+	public String checkAction(PartyId actor, Action action) {
+		String msg = super.checkAction(actor, action);
+		if (msg != null)
+			return msg;
 
-	public SAOPState with(PartyId actor, Action action) {
-
-		if (actor == null) { // this is a bug
-			throw new IllegalArgumentException("actor must not be null");
-		}
-		if (!actor.equals(getNextActor())) {
-			throw new IllegalArgumentException("Party does not have the turn ");
-
-		}
-		if (action == null) {
-			throw new IllegalArgumentException("action is null");
-		}
-		if (!actor.equals(action.getActor())) {
-			throw new IllegalArgumentException(
-					"act contains wrong credentials: " + action);
-		}
+		if (!actor.equals(getNextActor()))
+			return "Party does not have the turn ";
 
 		// check protocol is followed for specific actions
 		if (action instanceof Accept) {
 			Bid bid = getLastBid();
-			if (bid == null) {
-				throw new IllegalArgumentException(
-						"Accept without a recent offer");
-			}
-			if (!bid.equals(((Accept) action).getBid())) {
-				throw new IllegalArgumentException(
-						"Party accepts a bid differing from the last offer ="
-								+ bid + ", action=" + action + ")");
-			}
+			if (bid == null)
+				return "Accept without a recent offer";
+
+			if (!bid.equals(((Accept) action).getBid()))
+				return "Party accepts a bid differing from the last offer ="
+						+ bid + ", action=" + action + ")";
+			return null;
 		} else if (action instanceof Offer) {
-			// offer is always fine. We don't check if bid is actually in domain
-			// or complete etc. We would need domain for that
+			return null;
 		} else if (action instanceof EndNegotiation) {
-			// just act, we will get into the final state then.
-		} else {
-			throw new IllegalArgumentException(
-					"Action " + action + " is not allowed in SAOP");
+			return null;
 		}
-
-		List<Action> newactions = new LinkedList<>(getActions());
-		newactions.add(action);
-		return new SAOPState(newactions, getConnections(), advanceProgress(),
-				getSettings(), getPartyProfiles(), null);
+		return "Action " + action + " is not allowed in SAOP";
 	}
 
@@ -232,17 +156,16 @@
 	 * 
 	 * @return the next actor in the current state. Assumes 1 action per actor
-	 *         every time.
+	 *         every time. NOTE if party disconnects this would jump wildly but
+	 *         nego stops then anyway
 	 */
 	protected PartyId getNextActor() {
 		return getConnections()
-				.get(getActions().size() % getConnections().size()).getParty();
+				.get(getActions().size() % getConnections().size());
 	}
 
 	/**
-	 * 
-	 * @param progress
 	 * @return new progress state
 	 */
-	private Progress advanceProgress() {
+	public Progress advanceProgress() {
 		Progress newprogress = getProgress();
 		if (newprogress instanceof ProgressRounds && isLastActor()) {
Index: protocol/src/main/java/geniusweb/protocol/tournament/ProfileList.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/ProfileList.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/tournament/ProfileList.java	(revision 31)
@@ -0,0 +1,68 @@
+package geniusweb.protocol.tournament;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+import com.fasterxml.jackson.annotation.JsonValue;
+
+import geniusweb.references.ProfileRef;
+
+/**
+ * Contains a list of profiles, one for each {@link Team} member.
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+public class ProfileList {
+	@JsonValue
+	private final List<ProfileRef> profiles; // field to ensure immutability
+
+	/**
+	 * 
+	 * @param ps a list of {@link ProfileRef}s. The length and order is
+	 *           important as each will be matched with the {@link Team} member
+	 *           at the same index.
+	 */
+	@JsonCreator
+	public ProfileList(List<ProfileRef> ps) {
+		this.profiles = new ArrayList<>(ps);
+	}
+
+	public List<ProfileRef> getProfiles() {
+		return Collections.unmodifiableList(profiles);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((profiles == null) ? 0 : profiles.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ProfileList other = (ProfileList) obj;
+		if (profiles == null) {
+			if (other.profiles != null)
+				return false;
+		} else if (!profiles.equals(other.profiles))
+			return false;
+		return true;
+	}
+
+	public String toString() {
+		return profiles.toString();
+	}
+}
Index: protocol/src/main/java/geniusweb/protocol/tournament/Team.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/Team.java	(revision 31)
+++ protocol/src/main/java/geniusweb/protocol/tournament/Team.java	(revision 31)
@@ -0,0 +1,74 @@
+package geniusweb.protocol.tournament;
+
+import java.util.ArrayList;
+import java.util.Collections;
+import java.util.List;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+import com.fasterxml.jackson.annotation.JsonValue;
+
+import geniusweb.references.PartyWithParameters;
+
+/**
+ * A team is a group of parties, each with their own parameters. Each will be
+ * coupled to a {@link ProfileList} in the generation phase of the protocol
+ *
+ */
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE, isGetterVisibility = Visibility.NONE)
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+public class Team {
+	@JsonValue
+	private final List<PartyWithParameters> parties; // ensure immutability
+
+	/**
+	 * 
+	 * @param ps a list of {@link PartyWithParameters}. Each party is always
+	 *           associated with the given parameters. The order of them is
+	 *           important as it will be matched with the order in the
+	 *           {@link ProfileList}.
+	 */
+	@JsonCreator
+	public Team(List<PartyWithParameters> ps) {
+		this.parties = new ArrayList<PartyWithParameters>(ps);
+	}
+
+	/**
+	 * 
+	 * @return list of all team {@link PartyWithParameters}.
+	 */
+	public List<PartyWithParameters> getParties() {
+		return Collections.unmodifiableList(parties);
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((parties == null) ? 0 : parties.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Team other = (Team) obj;
+		if (parties == null) {
+			if (other.parties != null)
+				return false;
+		} else if (!parties.equals(other.parties))
+			return false;
+		return true;
+	}
+
+	public String toString() {
+		return parties.toString();
+	}
+}
Index: protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/tournament/TournamentSettings.java	(revision 31)
@@ -5,4 +5,5 @@
 import geniusweb.protocol.NegoSettings;
 import geniusweb.protocol.tournament.allpermutations.AllPermutationsSettings;
+import geniusweb.protocol.tournament.allpermutationslearn.AllPermutationsLearnSettings;
 import tudelft.utilities.logging.Reporter;
 
@@ -10,5 +11,6 @@
  * Interface for tournament settings
  */
-@JsonSubTypes({ @JsonSubTypes.Type(value = AllPermutationsSettings.class) })
+@JsonSubTypes({ @JsonSubTypes.Type(value = AllPermutationsSettings.class),
+		@JsonSubTypes.Type(value = AllPermutationsLearnSettings.class) })
 public interface TournamentSettings extends NegoSettings {
 	@Override
Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsSettings.java	(revision 31)
@@ -14,4 +14,6 @@
 import geniusweb.protocol.session.saop.SAOPSettings;
 import geniusweb.protocol.session.shaop.SHAOPSettings;
+import geniusweb.protocol.tournament.ProfileList;
+import geniusweb.protocol.tournament.Team;
 import geniusweb.protocol.tournament.TournamentProtocol;
 import geniusweb.protocol.tournament.TournamentSettings;
@@ -59,10 +61,10 @@
 public class AllPermutationsSettings implements TournamentSettings {
 
-	private final List<Team> teams;
-	private final List<ProfileList> profileslists;
-	private final boolean reuseTeams;
-	private final int teamsPerSession;
-	private final SessionSettings sessionsettings;
-	private final int numberTournaments;
+	protected final List<Team> teams;
+	protected final List<ProfileList> profileslists;
+	protected final boolean reuseTeams;
+	protected final int teamsPerSession;
+	protected final SessionSettings sessionsettings;
+	protected final int numberTournaments;
 
 	/**
@@ -81,7 +83,6 @@
 	 * @param teamsPerSession number of parties per session, must be at least 2.
 	 * @param sesettings      The generic {@link SessionSettings}.
-	 *                        {@link SessionSettings#with(TeamInfo)}
-	 *                        will be used to add the required
-	 *                        {@link TeamInfo}s
+	 *                        {@link SessionSettings#with(TeamInfo)} will be
+	 *                        used to add the required {@link TeamInfo}s
 	 * @param nTournaments    the number of times the tournament should be run.
 	 */
@@ -158,7 +159,11 @@
 	@Override
 	public String toString() {
-		return "AllPermutationsSettings[" + teams + "," + reuseTeams + ","
-				+ profileslists + "," + teamsPerSession + "," + sessionsettings
-				+ "," + numberTournaments + "]";
+		return "AllPermutationsSettings[" + contentString() + "]";
+	}
+
+	protected String contentString() {
+		return teams + "," + reuseTeams + "," + profileslists + ","
+				+ teamsPerSession + "," + sessionsettings + ","
+				+ numberTournaments;
 	}
 
@@ -216,5 +221,5 @@
 	 * @return {@link SessionSettings}
 	 */
-	private SessionSettings createSetting(
+	protected SessionSettings createSetting(
 			ImmutableList<TeamInfo> partyproflist) {
 		SessionSettings settings = sessionsettings;
@@ -227,14 +232,14 @@
 	/**
 	 * 
-	 * @param parties
-	 * @param profiles
-	 * @param n                    number of items to draw. Assumed >= 1.
+	 * @param parties              the parties in the tournament
+	 * @param profiles             the profiles in the tournament
+	 * @param n                    number of items to draw. Assumed &ge;1.
 	 * @param drawPartyWithPutback if parties can be drawn multiple times
 	 * @return list of sessionsets where each sessionset contains settings for a
-	 *         session: a list with {@link TeamInfo}s. The
-	 *         sessionsets are made by making all combinations of parties and
-	 *         profiles. Profiles are drawn with replace.
-	 */
-	private ImmutableList<ImmutableList<TeamInfo>> getParticipants(
+	 *         session: a list with {@link TeamInfo}s. The sessionsets are made
+	 *         by making all combinations of parties and profiles. Profiles are
+	 *         drawn with replace.
+	 */
+	protected ImmutableList<ImmutableList<TeamInfo>> getParticipants(
 			ImmutableList<Team> parties, ImmutableList<ProfileList> profiles,
 			int n, boolean drawPartyWithPutback) {
@@ -257,7 +262,6 @@
 		MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamInfo>> tournamentsettings = new MapList<Tuple<ImmutableList<Team>, ImmutableList<ProfileList>>, ImmutableList<TeamInfo>>(
 				tuple -> teamlist(tuple), tuples);
-		return new Repeat<ImmutableList<TeamInfo>>(
-				tournamentsettings, BigInteger.valueOf(numberTournaments),
-				true);
+		return new Repeat<ImmutableList<TeamInfo>>(tournamentsettings,
+				BigInteger.valueOf(numberTournaments), true);
 	}
 
@@ -273,6 +277,5 @@
 		BiFunction<Team, ProfileList, TeamInfo> makeparty = new BiFunction<Team, ProfileList, TeamInfo>() {
 			@Override
-			public TeamInfo apply(Team team,
-					ProfileList profilelist) {
+			public TeamInfo apply(Team team, ProfileList profilelist) {
 				List<PartyWithParameters> parties = team.getParties();
 				List<ProfileRef> profiles = profilelist.getProfiles();
@@ -291,6 +294,6 @@
 
 		};
-		return new MapThreadList<TeamInfo, Team, ProfileList>(
-				makeparty, tuple.get1(), tuple.get2());
+		return new MapThreadList<TeamInfo, Team, ProfileList>(makeparty,
+				tuple.get1(), tuple.get2());
 	}
 
Index: protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java
===================================================================
--- protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 30)
+++ protocol/src/main/java/geniusweb/protocol/tournament/allpermutations/AllPermutationsState.java	(revision 31)
@@ -15,8 +15,8 @@
 public class AllPermutationsState implements TournamentState {
 
-	private final AllPermutationsSettings toursettings; // original settings
-	private final ImmutableList<SessionSettings> sessionsettings;
+	protected final AllPermutationsSettings toursettings; // original settings
+	protected final ImmutableList<SessionSettings> sessionsettings;
 	// limited to MAX_INT elements. But we need to store results anyway
-	private final List<SessionResult> results;
+	protected final List<SessionResult> results;
 
 	public AllPermutationsState(AllPermutationsSettings toursettings,
